"""Establishment url patterns for backoffice."""

from django.urls import path

from establishment import views
from search_indexes.views import EstablishmentBackOfficeDocumentViewSet, EmployeesBackDocumentViewSet

app_name = 'establishment'

urlpatterns = [
    path('', views.EstablishmentListCreateView.as_view(), name='create'),
    path('list/', EstablishmentBackOfficeDocumentViewSet.as_view({'get': 'list'}), name='list'),
    path('slug/<slug:slug>/', views.EstablishmentRUDView.as_view(), name='detail'),
    path('slug/<slug:slug>/schedule/<int:schedule_id>/', views.EstablishmentScheduleRUDView.as_view(),
         name='schedule-rud'),
    path('slug/<slug:slug>/schedule/', views.EstablishmentScheduleListCreateView.as_view(),
         name='schedule-create-list'),
    path('slug/<slug:slug>/holidays/<int:holiday_id>/',
         views.EstablishmentHolidaysCDLViewSet.as_view({'delete': 'destroy'}),
         name='schedule-destroy'),
    path('slug/<slug:slug>/holidays/', views.EstablishmentHolidaysCDLViewSet.as_view({'get': 'list', 'post': 'create'}),
         name='schedule-list-create'),
    path('slug/<slug:slug>/gallery/', views.EstablishmentGalleryListView.as_view(),
         name='gallery-list'),
    path('slug/<slug:slug>/gallery/<int:image_id>/',
         views.EstablishmentGalleryCreateDestroyView.as_view(),
         name='gallery-create-destroy'),
    path('slug/<slug:slug>/companies/', views.EstablishmentCompanyListCreateView.as_view(),
         name='company-list-create'),
    path('slug/<slug:slug>/companies/<int:company_pk>/', views.EstablishmentCompanyRUDView.as_view(),
         name='company-rud'),
    path('slug/<slug:slug>/notes/', views.EstablishmentNoteListCreateView.as_view(),
         name='note-list-create'),
    path('slug/<slug:slug>/notes/<int:note_pk>/', views.EstablishmentNoteRUDView.as_view(),
         name='note-rud'),
    path('slug/<slug:slug>/admin/', views.EstablishmentAdminView.as_view(),
         name='establishment-admin-list'),
    path('slug/<slug:slug>/guides/<int:guide_id>/', views.EstablishmentGuideCreateDestroyView.as_view(),
         name='guide-list-create'),
    path('menus/dishes/', views.MenuDishesListCreateView.as_view(), name='menu-dishes-list'),
    path('menus/dishes/<int:pk>/', views.MenuDishesRUDView.as_view(), name='menu-dishes-rud'),
    path('menus/dishes/<int:pk>/gallery/', views.MenuGalleryListView.as_view(), name='menu-dishes-gallery-list'),
    path('menus/dishes/<int:pk>/gallery/<int:image_id>/', views.MenuGalleryCreateDestroyView.as_view(),
         name='menu-dishes-gallery-create-destroy'),
    path('menus/', views.MenuListCreateView.as_view(), name='menu-list'),
    path('menus/create/<int:establishment_id>/', views.CreateMenuForCertainEstablishmentView.as_view(),
         name='menu-list'),
    path('card_and_wines/<int:establishment_id>/', views.CardAndWinesListView.as_view(), name='card-and-wines-get'),
    path('menus/<int:menu_id>/', views.MenuRUDView.as_view(), name='menu-rud'),
    path('menus/dish/<int:establishment_id>/', views.DishCreateView.as_view(), name='create-dish'),
    path('menus/dish/change/<int:dish_id>/', views.DishUpdateDeleteView.as_view(), name='update-delete-dish'),
    path('menus/wine/<int:establishment_id>/', views.EstablishmentWineView.as_view(), name='menu-wine'),
    path('menus/uploads/<int:pk>/', views.MenuUploadsRUDView.as_view(), name='menu-uploads-rud'),
    path('menus/uploads/', views.MenuUploadsCreateView.as_view(), name='menu-uploads-create'),
    path('plates/', views.PlateListCreateView.as_view(), name='plates'),
    path('plates/<int:pk>/', views.PlateRUDView.as_view(), name='plate-rud'),
    path('social_choice/', views.SocialChoiceListCreateView.as_view(), name='socials_choice'),
    path('social_choice/<int:pk>/', views.SocialChoiceRUDView.as_view(), name='socials_choice-rud'),
    path('socials/', views.SocialListCreateView.as_view(), name='socials'),
    path('socials/<int:pk>/', views.SocialRUDView.as_view(), name='social-rud'),
    path('phones/', views.PhonesListCreateView.as_view(), name='phones'),
    path('phones/<int:pk>/', views.PhonesRUDView.as_view(), name='phones-rud'),
    path('emails/', views.EmailListCreateView.as_view(), name='emails'),
    path('emails/<int:pk>/', views.EmailRUDView.as_view(), name='emails-rud'),
    path('<int:establishment_id>/employees/', views.EstablishmentEmployeeListView.as_view(),
         name='establishment-employees'),
    path('employees/', views.EmployeeListCreateView.as_view(), name='employees'),
    path('employees/search/', views.EmployeesListSearchViews.as_view(), name='employees-search'),
    path('employees/list/', EmployeesBackDocumentViewSet.as_view({'get': 'list'}), name='employees-elastic'),
    path('employees/<int:pk>/', views.EmployeeRUDView.as_view(), name='employees-rud'),
    path('employees/<int:pk>/<int:award_id>', views.RemoveAwardView.as_view(), name='employees-award-delete'),
    path('<int:establishment_id>/employee/<int:employee_id>/position/<int:position_id>/',
         views.EstablishmentEmployeeCreateView.as_view(),
         name='employees-establishment-create'),
    path('employee/position/<int:pk>/delete/', views.EstablishmentEmployeeDeleteView.as_view(),
         name='employees-establishment-delete'),
    path('types/', views.EstablishmentTypeListCreateView.as_view(), name='type-list'),
    path('types/<int:pk>/', views.EstablishmentTypeRUDView.as_view(), name='type-rud'),
    path('subtypes/', views.EstablishmentSubtypeListCreateView.as_view(), name='subtype-list'),
    path('subtypes/<int:pk>/', views.EstablishmentSubtypeRUDView.as_view(), name='subtype-rud'),
    path('positions/', views.EstablishmentPositionListView.as_view(), name='position-list'),
    path('employee_positions/<int:pk>/', views.EmployeePositionsListView.as_view(),
         name='employee-positions-list'),
    path('employee_establishments/<int:pk>/', views.EmployeeEstablishmentsListView.as_view(),
         name='employee-establishments-list'),
    path('available_statuses/', views.StatusesListView.as_view(), name='statuses-list'),
    path('employee_establishment_positions/<int:pk>/', views.EmployeeEstablishmentPositionsView.as_view(),
         name='employee-establishment-positions'),
    path('team/<int:establishment_id>', views.TeamMemberListView.as_view(), name='establishment-team-members-list'),
    path('team/<int:establishment_id>/<int:user_id>', views.TeamMemberDeleteView.as_view(),
         name='establishment-team-member-delete'),
    path('awards/create-and-bind/<int:establishment_id>/',
         views.EstablishmentAwardCreateAndBind.as_view(),
         name='establishment-awards-create-and-bind'),
    path('awards/create-and-bind/<int:establishment_id>/<int:award_id>/',
         views.EstablishmentAwardCreateAndBind.as_view(),
         name='establishment-awards-create-and-bind', ),
    path('for_admin/employees/', views.AdminEmployeeListView.as_view(), name='employees-list-for-admin'),
    path('for_admin/establishments/', views.AdminEstablishmentListView.as_view(), name='establishments-list-for-admin'),
]
